package it.unina.instrumented.korel.quad;


/**
 * Classe che fornisce la "funzione quad" da testare
 * 
 * @author francesco
 * 
 */
public class Quad {

	private Integer numTestRequirements = 3;
	private Double[] korelValues = new Double[2 * numTestRequirements];
	private Boolean[] isReached = new Boolean[numTestRequirements];

	public Double[] getKorelValues() {
		return korelValues;
	}

	public Boolean[] getIsReached() {
		return isReached;
	}
	
	/**
	 * metodo che valuta se l'equazione di secondo grado "a*(x^2) + b*x + c = 0"
	 * ha 2 soluzioni, 1 oppure soluzioni immaginarie
	 * 
	 * @param a
	 * @param b
	 * @param c
	 * @return
	 */
	public String quad(double a, double b, double c) {

		
		double discr, root1, root2;
		String result = "";

		// Solve the discriminant
		discr = (b * b) - (4 * a * c);

		// Determine number of roots
		// if discr > 0 equation has 2 real roots
		// if discr == 0 equation has a repeated real root
		// if discr < 0 equation has imaginary roots

		korelValues[0] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.GREATER_THEN_OP);
		korelValues[1] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.LESS_EQUAL_OP);
		
		if ((isReached[0]=(discr > 0)) && (discr > 0) ){
			result += "Equation has 2 roots";
			root1 = (-b + Math.sqrt(discr)) / (2 * a);
			root2 = (-b - Math.sqrt(discr)) / (2 * a);
			result += " First root = " + root1;
			result += " Second root = " + root2;
		}

		korelValues[2] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.EQUAL_OP);
		korelValues[3] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.NOT_EQUAL_OP);
		
		if ((isReached[1]=(discr == 0)) && (discr == 0)) {
			result += "Equation has 1 root";
			root1 = -b / (2 * a);
			result += " Root = " + root1;
		}

		korelValues[4] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.LESS_THEN_OP);
		korelValues[5] = KorelFunction.korelFunction(discr, 0,
				KorelFunction.GREATER_EQUAL_OP);
		
		if ((isReached[2]=(discr < 0)) && (discr < 0))
			result += "Equation has imaginary roots";

		return result;

	}
}
